{
  a Z-80 assembly language compiler for ZX-SPECTRUM (48/128/512/1024)

  DESCRIPT: errors handler.

                                 was written by SCREW/OHG/CM
                                   all rights reserved
}
Unit C_ErrHandle;

INTERFACE

Function W_Error:string;
Procedure Error(err_num:byte);
Procedure Remove_errors;
Function Get_error:byte;
Function Translator_Error:boolean;
Procedure Remove_counter;
Function Get_Counter:integer;
Procedure Inc_Counter;

Var
    err_check:byte;   { 0 -Ok, <>0 - Number of error.}
    counter:longint;

IMPLEMENTATION
{$I C_Z80ERR.pas} {include errors definition }

{================ HANDLDE TO ALL ERRORS ===================================}
Procedure Remove_counter;
Begin counter:=0 end;

Function Get_Counter:integer;
Begin Get_Counter:=counter end;

Procedure Inc_Counter;
Begin inc(counter) end;


Function W_Error:string;
Const Ers:array[128..144] of string=(
      'Unknown mnemonic','Syntax error','Invalid opcode size',
      'Invalid indexing mode','Wrong if condition',
      'Invalid using registers','Relative jump is too far',
      'Too many labels','Label already exists','Too many macros',
      'Macros is too large','Infinite recurse','Macros parameter miss',
      'Too many macros parameters','Too many EQUals',
      'EQUal already exists','ORG is not assigned');

Begin
 if err_check=0 then W_Error:='' else
 if (err_check>=128) and
    (err_check<=144) then W_Error:=ers[err_check] else
 W_Error:='unknown error';
end;

Procedure Error(err_num:byte);
Begin
 if err_check=0 then err_check:=err_num;
 if err_num<>0 then
end;

Procedure Remove_errors;
Begin
 err_check:=0
end;

Function Get_error:byte;
Begin
 Get_Error:=err_check
end;

Function Translator_Error:boolean;
Begin
 Translator_Error:=(err_check>=UNKNOWN_MNEMONIC)
               and (err_check<=RELATIVE_JUMP_IS_TOO_FAR)
end;

end.